.386
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\masm32.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\masm32.lib
includelib \masm32\lib\user32.lib 
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
TopXY PROTO :DWORD,:DWORD

RGB MACRO red,green,blue
  xor eax,eax
  mov ah,blue
  shl eax,8
  mov ah,green
  mov al,red
endm 

.DATA
 ClassName db "STClass",0
 AppName db "Static Test",0
 Static db "STATIC",0 
 TMain db "mTimer",0

.DATA?
 hInstance HINSTANCE ?
 CommandLine LPSTR ?
 sWid dd ?
 sHgt dd ?
 hcgname dd ?

.CONST
  
.CODE
start:

 invoke GetModuleHandle, NULL
 mov hInstance,eax
 invoke GetCommandLine 
 mov CommandLine,eax

 invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
 invoke ExitProcess, eax

 WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    LOCAL hwnd:HWND
    LOCAL Wwd:DWORD,Wht:DWORD,Wtx:DWORD,Wty:DWORD

    invoke GetSystemMetrics,SM_CXSCREEN
    mov sWid, eax
    invoke GetSystemMetrics,SM_CYSCREEN
    mov sHgt, eax
    mov   wc.cbSize,SIZEOF WNDCLASSEX
    mov   wc.style, CS_HREDRAW or CS_VREDRAW
    mov   wc.lpfnWndProc, OFFSET WndProc
    mov   wc.cbClsExtra,NULL
    mov   wc.cbWndExtra,NULL
    push  hInstance
    pop   wc.hInstance
    invoke LoadIcon,hInstance,IDI_APPLICATION
    mov   wc.hIcon,eax
    RGB 57,88,41
    Invoke CreateSolidBrush, eax
    mov   wc.hbrBackground, eax
    mov   wc.lpszMenuName, NULL
    mov   wc.lpszClassName,OFFSET ClassName
    invoke LoadIcon,NULL,IDI_APPLICATION
    mov   wc.hIconSm,0
    invoke LoadCursor,NULL,IDC_ARROW
    mov   wc.hCursor,eax
    invoke RegisterClassEx, addr wc    
    mov Wwd, 421
    mov Wht, 311
    invoke TopXY,Wwd,sWid
    mov Wtx, eax
    invoke TopXY,Wht,sHgt
    mov Wty, eax
    invoke CreateWindowEx, WS_EX_CLIENTEDGE,ADDR ClassName, \
               ADDR AppName, WS_OVERLAPPED or WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX,\
               Wtx,Wty,Wwd,Wht,NULL,NULL, hInst,NULL 
    mov hwnd,eax
    invoke ShowWindow, hwnd,CmdShow
    invoke UpdateWindow, hwnd
   StartLoop:
    Invoke GetMessage,ADDR msg,NULL,0,0
    cmp eax, 0
    je ExitLoop
    Invoke TranslateMessage, ADDR msg
    Invoke DispatchMessage,  ADDR msg
    jmp StartLoop
   ExitLoop:
    mov eax,msg.wParam
    ret
 WinMain endp

 WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    LOCAL ps:PAINTSTRUCT

    cmp uMsg, WM_DESTROY
    jne @F
     invoke PostQuitMessage,NULL
     jmp Return
    @@:
    cmp uMsg, WM_CREATE
    jne @F


        invoke CreateWindowEx, NULL, ADDR Static,NULL, WS_CHILD or WS_VISIBLE or ES_CENTER,  10,23,169,18,hWnd,15,hInstance,NULL
        mov hcgname, eax


        Invoke SetTimer, hWnd, ADDR TMain, 100, NULL


      jmp Return
    @@:
    cmp uMsg, WM_PAINT
    jne @F
      invoke BeginPaint,hWnd,addr ps
      RGB 57,88,41
      Invoke CreateSolidBrush, eax
      invoke SetBkColor,hWnd,eax
      invoke EndPaint,hWnd,addr ps
    jmp Return
    @@:
    cmp uMsg, WM_CTLCOLORSTATIC
    jne @F
     mov eax, lParam
       RGB 235,235,230
       invoke SetTextColor,wParam,eax
       RGB 57,88,41
       invoke SetBkColor,wParam,eax
       RGB 57,88,41
       Invoke CreateSolidBrush, eax
     ret
    jmp Return
    @@:
    cmp uMsg, WM_COMMAND
    jne @F
        mov eax,wParam

     jmp Return
    @@:
    cmp uMsg, WM_TIMER
    jne @F


      Invoke SetWindowText, hcgname, ADDR AppName
      Invoke InvalidateRect, hWnd, FALSE, TRUE


     jmp Return
    @@:
      invoke DefWindowProc,hWnd,uMsg,wParam,lParam
      ret
    Return:
    xor eax,eax
    ret
 WndProc endp

 TopXY proc wDim:DWORD, sDim:DWORD
   shr sDim, 1
   shr wDim, 1
   mov eax, wDim
   sub sDim, eax
   mov eax, sDim
   ret
 TopXY endp
end start 